function Clip( _paper, _imageFileName, _numFrames, _famesX, _framesY, _framesWidth, _framesHeight, _framesRotation, _framesAlpha, _checkPoints, _framesGoto, _framesResume, _loadCallback, _speechFlag, _animFrames, _xmlAnim, _zoomCont) {
	var paper = _paper;
	var imageFileName = _imageFileName;
	var imageWidth = 100;
	var imageHeight = 100;
	var image;
	var framesX = _famesX;	
	var framesY = _framesY;	
	var framesWidth = _framesWidth;	
	var framesHeight = _framesHeight;	
	var framesRot = _framesRotation;	
	var framesAlpha = _framesAlpha;	
	var checkPoints = _checkPoints;	
	var framesGoto = _framesGoto;
	var framesResume = _framesResume;
	var numFrames = _numFrames;
	var curAlpha = 0;
	var preloadImage;
	var loadCallback = _loadCallback;
	var animPaused = false;
	var animLooping = false;
	var speechFlag = _speechFlag;
	var stickman;
	var lastHeight;
	var animFrames = _animFrames;
	var xmlAnim = _xmlAnim;
	var elSet;
	var prevX;
	var prevY;
	var prevRotate;
	var curRotate = 0;
	var curSetRotate = 0;
	var setFirstRot = 0;
	var setFirstWidth = 0;
	var setFirstHeight = 0;
	var curX = 0;
	var curY = 0;
	var curWidth = 0;
	var curHeight = 0;
	var zoomCont = _zoomCont;
  var offsetX = 0;
  var offsetY = 0;
  var isText = false;
  var fontSize = null;
	
	var curFrame = 0;
	var nonLoopFrame = 0;
  
  var imageLoaded = function() {
    if (G.usingCanvas){
      image = new Kinetic.Image({
        x: framesX[0],
        y: framesY[0],
        width: framesWidth[0],
        height: framesHeight[0],
        image: preloadImage
      });
      paper.add(image);
    }
    else{
      // if (imageFileName == "aaah.png" ||
          // imageFileName == "allover.png" ||
          // imageFileName == "badbeaver.png" ||
          // imageFileName == "becreative.png" ||
          // imageFileName == "boing.png" ||
          // imageFileName == "cantlook.png" ||
          // imageFileName == "chomp.png" ||
          // imageFileName == "climbon.png" ||
          // imageFileName == "drawaladder.png" ||
          // imageFileName == "drawaweight.png" ||
          // imageFileName == "drawbucket.png" ||
          // imageFileName == "drawmachine1.png" ||
          // imageFileName == "epclimbon.png" ||
          // imageFileName == "everyday.png" ||
          // imageFileName == "goodcostume.png" ||
          // imageFileName == "handyelevator.png" ||
          // imageFileName == "help1.png" ||
          // imageFileName == "help2.png" ||
          // imageFileName == "hoo.png" ||
          // imageFileName == "iknow1.png" ||
          // imageFileName == "itsstuck.png" ||
          // imageFileName == "needtrampoline.png" ||
          // imageFileName == "nocostume.png" ||
          // imageFileName == "ohno.png" ||
          // imageFileName == "pressbackbutton.png" ||
          // imageFileName == "ring.png" ||
          // imageFileName == "someoneindanger.png" ||
          // imageFileName == "thanks.png" ||
          // imageFileName == "theend.png" ||
          // imageFileName == "thinkfast.png" ||
          // imageFileName == "tick.png" ||
          // imageFileName == "tigercostume.png" ||
          // imageFileName == "tweet.png" ||
          // imageFileName == "uhohtiger.png" ||
          // imageFileName == "zzzz.png"){
        // image = getTextFor(imageFileName,paper,0,0);
        // fontSize = image.attr("font-size");
        // var bBox = image.getBBox();
        // offsetX = bBox.width / 2;
        // offsetY = bBox.height / 2 + 10;
        // isText = true;
      // }
      // else{
        image = paper.image("images/" + imageFileName, 0,0, framesWidth[0], framesHeight[0]);
      // }
      image.hide();
    }
		loadCallback();
	}
  this.setZIndex = function() {
    if (G.usingCanvas){
      image.setZIndex(zIndex);
    }
    else{
      image.toFront();
      image.show();
    }
  };
	
	this.loadImage = function() {
		preloadImage = new Image();
		preloadImage.onload = imageLoaded;
    preloadImage.src = "images/" + imageFileName;
	}
	// var imageLoaded = function() {
		// preloadImage.onLoad = null;
		// loadCallback();
	// }
	// this.loadImage = function() {
		// image = paper.image("images/" + imageFileName, 0, 0, framesWidth[0], framesHeight[0]).hide();
		// preloadImage = new Image();
		// preloadImage.src = "images/" + imageFileName;
		// preloadImage.onLoad=imageLoaded();
	// }
		
	this.animateFrame = function( numFramesToAnimate, zoomAnimated ){
		var noAnim = true;
		for (var i = 0; i < numFramesToAnimate; i++) {
			if (curFrame > numFrames || animPaused == true && animLooping == false) {
			
			}
			else {
				if (animFrames[curFrame] != true) {
					curFrame ++;
					if (animPaused == false) nonLoopFrame ++;
				}
				else {			
					if (framesX[curFrame] != null) var newX = framesX[curFrame] + offsetX;
					if (framesY[curFrame] != null) var newY = framesY[curFrame] + offsetY;
					if (framesWidth[curFrame] != null) {
            var newWidth = framesWidth[curFrame];
            var newScaleX = framesWidth[curFrame] / framesWidth[0];
          }
					if (framesHeight[curFrame] != null) {
            var newHeight = framesHeight[curFrame];
            var newScaleY = framesHeight[curFrame] / framesHeight[0];
          }
					if (framesAlpha[curFrame] != null) {
						var newAlpha = framesAlpha[curFrame];
					}
					if (framesGoto[curFrame] != null) var newGoto = framesGoto[curFrame];
					if (framesRot[curFrame] != null) var newRotate = framesRot[curFrame];
					
					curFrame ++;
					if (animPaused == false) {
						nonLoopFrame ++;
					}
					
					// Loop the animation
					if (newGoto != null) {
						animLooping = true;
						curFrame = checkPoints[ newGoto ];
						newGoto = null;
					}

					// End the loop
					if (framesResume[nonLoopFrame] != null) {
						animLooping = false;
						curFrame = nonLoopFrame;
					}
					noAnim = false;
				}
			}
		}
    
		if (noAnim == true && zoomAnimated == false) return;
    
    if (isText){
      var scale = newScaleX + newScaleY / 2;
      image.attr({"font-size":scale * fontSize});
      
      if (imageFileName == "boing.png"){
        if (newRotate != null){
          newRotate -= 90;
        }
        if (newScaleY != null){
          newY = newY + 150;
        }
      }
    }
		
		if (imageFileName == "titlebar.png") {
			var title = true;
		}

		xmlAnim.setClipFrame( curFrame );
		
		if (newY != null && speechFlag == true && stickman != null) newY = stickman.getTopPos() - curHeight - 20;
		
		if (newX != null) curX = newX;
		if (newY != null) curY = newY;
		if (newRotate != null) curRotate = newRotate;
		if (newWidth != null) curWidth = newWidth;
		if (newHeight != null) curHeight = newHeight;
		
		try {
		if (newWidth != null && newHeight != null || zoomAnimated == true) image.attr({width: zoomCont.zoomSize( curWidth ), height: zoomCont.zoomSize( curHeight ) });
		else if (newWidth != null) image.attr({width: zoomCont.zoomSize( newWidth ) });
		else if (newHeight != null) image.attr({height: zoomCont.zoomSize( newHeight ) });
		
		if (newX != null || newY != null || newRotate != null || zoomAnimated == true) image.transform( ["R", curRotate, ",0,0", "T", zoomCont.zoomX( curX ), ",", zoomCont.zoomY( curY ) ].join("") );
		
		if (newAlpha != null && newAlpha != curAlpha) {
			if (newAlpha == 0) {
				image.hide();
			}
			else image.show();
			curAlpha = newAlpha;
		}
		
		if (elSet != null) {
			if (newX != null || newY != null || newRotate != null || newWidth != null || newHeight != null || zoomAnimated == true) {
				var elSetScaleX = curWidth / setFirstWidth;
				var elSetScaleY = curHeight / setFirstHeight;
				if (elSetScaleX == 1 && elSetScaleY == 1) elSet.transform( ["R", (curRotate - setFirstRot), ",", setFirstX, ",", setFirstY, "T", (curX - setFirstX), ",", (curY - setFirstY)].join("") );
				else elSet.transform( ["S", elSetScaleX, ",", elSetScaleY, ",", setFirstX, ",", setFirstY, "R", (curRotate - setFirstRot), ",", setFirstX, ",", setFirstY, "T", (curX - setFirstX), ",", (curY - setFirstY)].join("") );
			}
		}
		}
		catch(e) {
			alert(e);
		}
	}
	
	this.groupWith = function( elementSet, offsetX, offsetY ) {
		setFirstRot = curRotate;
		setFirstX = curX - offsetX;
		setFirstY = curY - offsetY;
		setFirstWidth = curWidth;
		setFirstHeight = curHeight;
		
		elSet = elementSet;
	}
	
	this.getImage = function() {
		return image;
	}
	this.getBoundsNoZoom = function() {
		var rect = new Rectangle( curX, curY, curX + curWidth, curY + curHeight );
		return rect;
	}
	
	this.pauseAnimation = function(){
		//if (animLooping == false) {
			animPaused = true;
		//}
		//else {
		//	animPaused = false;
		//	animPausedWithLoop = true;
		//}
	}
	this.resumeAnimation = function(){
		animPaused = false;
		//animPausedWithLoop = false;
	}
	
	this.setStickman = function( _stickman ) {
		stickman = _stickman;
	}
	
	this.getX = function() {
		return curX;
	}
	this.getY = function() {
		return curY;
	}
	this.endAnimation = function() {
		numFrames = curFrame;
	}
	
	this.cleanUp = function() {
		paper = null;
		imageFileName = null;
		imageWidth = null;
		imageHeight = null;
		image = null;
		framesX = null;
		framesY  = null;
		framesWidth = null;
		framesHeight = null;
		framesRot = null;
		framesAlpha = null;
		checkPoints = null;
		framesGoto = null;
		framesResume = null;
		numFrames = null;
		curAlpha = null;
		preloadImage = null;
		loadCallback = null;
		animPaused = null;
		animLooping = null;
		speechFlag = null;
		stickman = null;
		lastHeight = null;
		animFrames = null;
		xmlAnim = null;
		elSet = null;
		prevX = null;
		prevY = null;
		prevRotate = null;
		curRotate = null;
		curSetRotate = null;
		setFirstRot = null;
		setFirstWidth = null;
		setFirstHeight = null;
		curX = null;
		curY = null;
		curWidth = null;
		curHeight = null;
		zoomCont = null;
	}
}