function XMLAnim( _paper, _loaderImage, _endingIsReadyFunction, _friendURL, _app, _goToSharePageFunction, _frameRate, _saver ) {
	var paper = _paper;
	var clips = new Array();
	var numClips = 0;
	var numLoaded = 0;
	var numDrawAreas = 0;
	var drawAreas = new Array();
	var pathGuides = new Array();
	var numPathGuides = 0;
	var eggGuide = 0;
	var xmlAnim = this;
	var doneButton;
	var clearButton;
	var stickmanGuide;
	var stickman;
	var clipsXML;
	var numClipsXMLLoaded;
	var xmlData;
	var key;
	var sword;
	var hardPause = false;
	var animatingEgg = false;
	var frameRate = _frameRate;
	var jsonData;
	var numPasses = 1;
	var cloud;
	var drain;
	var animatingCloud = false;
	var endCountNum = 0;
	var endCounting = false;
	var phraseOneStr = "Dream It";
	var phraseTwoStr = "Real";
	var phraseOne = new Array();
	var phraseTwo = new Array();
	var maxLineOne = 17;
	var maxLineTwo = 14;
	var justPaused = false;
	var curFrameNum = 0;
	var hardPausePending = false;
	var pausePending = false;
	var ladder;
	var ladderGuide;
	var ladder2Guide;
	var stickman2;
	var stickman2Guide;
	var callAfterFrameEnabled;
	var afterFrameFunctionID;
	var afterFrameFunctions = new Object();
	var ladder2;
	var costume;
	var costume2;
	var costumeColor = "#fa7a52";
	var costumeStrokeWidth = 2;
	var animatingHat = false;
	var stickmanPathGroup;
	var stickman2PathGroup;
	var stickmanFrame = 0;
	var moonGuide;
	var moon;
	var weight;
	var weightGuide;
	var animSoftPaused = false;
	var machine;
	var elevator;
	var elevator2;
	var cookieManager = new CookieManager();
	var loaderImage = _loaderImage;
	var friendMode = false;
	var ladderJSON;
	var endingIsReadyFunction = _endingIsReadyFunction;
	var goToSharePageFunction = _goToSharePageFunction;
	var friendURL = _friendURL;
	var friendStickmanData;
	var friendLadderData;
	var friendCostumeData;
	var friendMachineData;
	var friendCostumePos;
	var costumePos;
	var costumeJSON;
	var waitingForAdClick = false;
	var animLoader = new AnimationLoader();
	var app = _app;
	var friendName;
	var zoomCont;
	var activeDrawings = new Array();
	var numActiveDrawings = 0;
	var stickman1ClimbingLadder = false;
	var saver = _saver;
	var saveData;
	var storyVersion = 2;
	var animatingBucket = false;
	var bucket;
	var bucketAnim;
	
	var clip_drawmachine1;
	var clip_icanhelp;
	var clip_iknow;
	var clip_allover;
	var clip_drawmachine;
	
	if (_frameRate == undefined) frameRate = 33;
	else frameRate = parseInt( _frameRate );
	
	var imageLoaded = function(){
		numLoaded ++;
		if (numLoaded >= numClips) {
			loaderImage.remove();
			disableScrolling();
			animateFrame();
		}
	}
	var time;
	var animateFrame = function(){
		if (hardPause == true) {
			return;
		}
		var start = (new Date).getTime();
		justPaused = false;
		callAfterFrameEnabled = false;
		if (curFrameNum > 280) {
			var startWalkTarget = 1;
		}
		var stickmanFramesAnimated = 0;
		var stickman2FramesAnimated = 0;
		for (var p = 0; p < numPasses; p++) {
			stickmanFramesAnimated += stickmanGuide.animateFrame( 1, curFrameNum + p );
			if (friendMode == true) stickman2FramesAnimated += stickman2Guide.animateFrame( 1, curFrameNum + p );
			
			for (i = 0; i < numDrawAreas; i++) {
				drawAreas[i].animateFrame( 1 );
			}
			if (hardPausePending == true || pausePending == true) {
				numPasses = p + 1;
				break;
			}
		}
		
		if (animSoftPaused == false) {
			curFrameNum += numPasses;
		}
		
		var zoomAnimated = zoomCont.animateFrame( numPasses );
		
		if (stickmanPathGroup != null) {
			if (stickmanFramesAnimated > 0 || zoomAnimated == true) stickmanPathGroup.draw();
		}
		if (stickman2PathGroup != null) {
			if (stickman2FramesAnimated > 0 || zoomAnimated == true) stickman2PathGroup.draw();
		}
    time = getTimer();
		for (var i = 0; i < numClips; i++) {
			clips[i].animateFrame( numPasses, zoomAnimated );
		}
		for (i = 0; i < numPathGuides; i++) {
			pathGuides[i].animateFrame( numPasses );
		}
		if (zoomAnimated == true) {
			for (i = 0; i < numActiveDrawings; i++) {
				activeDrawings[i].draw();
			}
		}
		if (animatingHat == true) {
			stickmanPathGroup.updateCostumeFall( numPasses );
			stickmanPathGroup.draw();
		}
		if (animatingBucket == true) {
			bucketAnim.animateFrame( numPasses, zoomAnimated );
		}
		
		if (hardPausePending == true) {
			executeHardPause();
		}
		if (pausePending == true) {
			executePause();
		}
    
		var diff = (new Date).getTime() - start;
		var timeForNextFrame = frameRate - diff;
		if (timeForNextFrame < 0) {
			numPasses = Math.round( -timeForNextFrame / frameRate ) + 2;
			if (numPasses > 5) numPasses = 5;
		} else numPasses = 1;
		if (timeForNextFrame <= 0) timeForNextFrame = 1;
		
		if (endCounting == true) {
			endCountNum++;
			if (endCountNum >= 260) {
				scrollDownOverlay();
				executeHardPause();
				return;
			}
		}
		
		if (callAfterFrameEnabled == true) {
			afterFrameFunctions[ afterFrameFunctionID ]();
		}
    
    var elapsedTime = getTimer() - time;
    if (elapsedTime < 33){
      timeForNextFrame = 33 - elapsedTime;
    }
    else{
      timeForNextFrame = 1;
    }
    time = getTimer();
		var animateInterval = setTimeout(animateFrame,timeForNextFrame);
	}
	
	this.setStickmanFrame = function( _stickmanFrame ) {
		stickmanFrame = _stickmanFrame;
	}
	this.setClipFrame = function( _clipFrame ) {
	}
	
	this.callFunctionAfterFrame = function( _afterFrameFunction ) {
		callAfterFrameEnabled = true;
		afterFrameFunctionID = _afterFrameFunction;
	}
	
	this.pauseAnimation = function(){
		pausePending = true;
	}
	
	var tlp = function() {
		a = document.location.href;
		var b = a.split('//')[1];
		var c = b.split('/')[0];
		return c;
	}
	
	var executePause = function() {
		//console.log("pauseAnimation");
		pausePending = false;
		numPasses = 1;
		justPaused = true;
		for (var i = 0; i < numClips; i++) {
			clips[i].pauseAnimation();
		}
		for (var i = 0; i < numDrawAreas; i++) {
			drawAreas[i].pauseAnimation();
		}
		for (var i = 0; i < numPathGuides; i++) {
			pathGuides[i].pauseAnimation();
		}
		stickmanGuide.pauseAnimation();
		if (friendMode == true) stickman2Guide.pauseAnimation();
		zoomCont.pauseAnimation();
		animSoftPaused = true;
	}
	pauseAll = this.pauseAll = function(){
		hardPausePending = true;
	}
	
	var executeHardPause = function() {
		//console.log("pauseAll");
		hardPausePending = false;
		hardPause = true;
		justPaused = true;
	}
	resumeAnimation = this.resumeAnimation = function(){
		//console.log("resumeAnimation");
		numPasses = 1;
		justPaused = true;
		animSoftPaused = false;
		for (var i = 0; i < numClips; i++) {
			clips[i].resumeAnimation();
		}
		for (i = 0; i < numDrawAreas; i++) {
			drawAreas[i].resumeAnimation();
		}
		for (i = 0; i < numPathGuides; i++) {
			pathGuides[i].resumeAnimation();
		}
		stickmanGuide.resumeAnimation();
		if (friendMode == true) stickman2Guide.resumeAnimation();
		zoomCont.resumeAnimation();
		if (hardPause == true) {
			hardPause = false;
			animateFrame();
		}
	}
	
	this.scrollDownOverlay = function(){
		$('#overlay').animate({top: '460'},{duration: 1500}, function() {});
    G.popup = true;
	}
	
	this.scrollUpOverlay = function(){
		$('#overlay').animate({top: '-400' }, {duration: 1500 }, function() {});
    G.popup = false;
	}
	
	this.setStickman = function( _stickman ) {
		stickman = _stickman;
		stickmanPathGroup = stickman.getPathGroup();
		stickmanGuide.setStickman( stickman );
		for (var i = 0; i < numClips; i++) {
			clips[i].setStickman( stickman );
		}
	}
	
	var ladderDrawn = function( _ladder ) {
		ladder = _ladder;
		stickman1ClimbingLadder = true;
		ladderGuide.setPathGroup( ladder );
		stickmanGuide.setNextWalkToLadder( ladder );
		activeDrawings = new Array(ladder);
		numActiveDrawings = activeDrawings.length;
	}
	
	var weightDrawn = function( _weight ) {
		weight = _weight;
		weightGuide.setPathGroup( weight );
		activeDrawings = new Array(weight);
		numActiveDrawings = activeDrawings.length;
	}
	
	var machineDrawn = function( _machine ) {
		//frameRate = 33;
		machine = _machine;
		activeDrawings = new Array();
		numActiveDrawings = 0;
		if (app == false) {
			startMachineAnim();
		}
	}
	
	var startMachineAnim = function() {
		machine.draw();
		var groupSet = machine.getGroupSet();
		elevator.groupWith( groupSet, 0, 0 );
		
		if (friendMode == true) {
			machine2 = new PathGroup( paper, zoomCont );
			machine2.setDataFromJSON( friendMachineData, "#e35c0d", 2 );
			machine2.draw();
			var groupSet2 = machine2.getGroupSet();
			groupSet2.transform("T-1000,0");
			elevator2.groupWith( groupSet2, elevator2.getX() - elevator.getX(), elevator2.getY() - elevator.getY() );
		}
		
		saveDateForEnding();
	}

	var stopElevator2 = function() {
		if (friendMode == false) {
			elevator2.endAnimation();
		}
	}
	var saveDateForEnding = function() {
		//pauseAll();
		
		var stickmanJSON = stickmanPathGroup.getDataForJSON();
		var machineJSON = machine.getDataForJSON();
		if (app == false) {
			if (friendMode == true) {
				var stickman2JSON = stickman2PathGroup.getDataForJSON();
				var machine2JSON = machine2.getDataForJSON();
				endingIsReady( new Array( stickmanJSON, machineJSON, stickman2JSON, machine2JSON ) );
			}
			else {
				endingIsReady( new Array( stickmanJSON, machineJSON ) );
			}
		}
		
		var costumePosArray = [costumePos.x, costumePos.y];
		var cookieArray = new Array( stickmanJSON, ladderJSON, costumeJSON, costumePosArray, machineJSON );
		var cookieArrayStr = JSON.stringify( cookieArray );
//		alert("uncompessed data length " + cookieArrayStr.length);
		//lzma.compress(cookieArrayStr, 1, cookieCompressed);
		cookieCompressed( cookieArrayStr );
	}
	
	var cookieCompressed = function(result) {
//		alert("compessed data length " + result.length);
		if (app == true) {
			saveData = result;
			//alert("saveData = " + saveData);
		}
		else {
			cookieManager.createCookie("stk", result, 0 );
		}
		
		//resumeAnimation();
	}
	
	var costumeDrawn = function( _costume ) {
//		frameRate = 33;
		costume = _costume;
		costumeJSON = costume.getDataForJSON();
		costumeJSONStr = JSON.stringify( costumeJSON );
		var stickman1Group = stickman.getPathGroup();
		costumePos = stickmanPathGroup.adjustPointForScreen( new Point(0,0) );
		
		costume.copyToAnotherPathGroup( stickmanPathGroup, costumeColor, costumeStrokeWidth );
		costume.clearDisplay();
		stickman1Group.draw();

		
//		costume.copyToAnotherPathGroup( stickman1Group, costumeColor, costumeStrokeWidth );
//		costume.clearDisplay();
//		startHatFall();
	}
	
	var drawCostume2 = function() {
		if (friendMode == true) {
			// Create second costume
			costume2 = new PathGroup( paper, zoomCont );
			//costume2Guide.setPathGroup( ladder2 );
			costume2.setDataFromJSON( friendCostumeData, costumeColor, costumeStrokeWidth, false );
			//costume2.translate( 250, -10 );
			
			var stickman2TL = stickman2PathGroup.adjustPointForScreen( new Point(0,0) );
			costume2.translate( stickman2TL.x - friendCostumePos.x, stickman2TL.y - friendCostumePos.y );
			costume2.redrawSlowly( costume2Drawn );
			
			pauseAll();
		}
	}
	
	var moonDrawn = function( _moon ) {
//		frameRate = 33;
		moon = _moon;
		moon.sendToBack();
		moonGuide.setPathGroup( moon );
		ladderJSON = ladder.getDataForJSON();
		ladder.clearDisplay();
		if (friendMode == true) ladder2.clearDisplay();
		activeDrawings = new Array(moon);
		numActiveDrawings = activeDrawings.length;
		resumeAnimation();
	}
	
	var bucketDrawn = function( _bucket ) {
//		frameRate = 33;

		bucket = _bucket;
		activeDrawings = new Array(bucket);
		numActiveDrawings = activeDrawings.length;
		bucket.draw();
		bucketAnim = new BucketAnim( bucket, xmlAnim );
		bucketAnim.startAnim();
		animatingBucket = true;
		
		ladderJSON = ladder.getDataForJSON();
		ladder.clearDisplay();
		if (friendMode == true) ladder2.clearDisplay();
		resumeAnimation();
	}
	
	this.bucketAnimFinished = function() {
		activeDrawings = new Array();
		numActiveDrawings = 0;
		animatingBucket = false;
	}
	
	var costume2Drawn = function() {
		var stickman2Group = stickman2.getPathGroup();
		costume2.copyToAnotherPathGroup( stickman2Group, costumeColor, costumeStrokeWidth );
		costume2.clearDisplay();
		stickman2Group.draw();
		
		resumeAnimation();
	}
	
	var hatAnimFinished = function() {
		animatingHat = false;
	}
	var startHatFall = function() {
		var hatFallSpeedX = -2;
		var hatFallSpeedY = -1;
		var hatGravity = .4;
		var hatDestinationY = 1500;
		animatingHat = true;
		
		stickmanPathGroup = stickman.getPathGroup();
		stickmanPathGroup.startCostumeFall( hatFallSpeedX, hatFallSpeedY, hatGravity, hatDestinationY, hatAnimFinished );
	}
  this.adClicked = function() {
    if (waitingForAdClick == true) {
      $('.FakeAd').hide();
      waitingForAdClick = false;
      resumeAnimation();
    }
  }
  var waitForAdClick = function() {
		executeHardPause();
		waitingForAdClick = true;
    $('.FakeAd').animate({"bottom": "0px"});
	}
	var drawSecondLadder = function() {
	}

	var querySt = function(ji) {
		hu = window.location.search.substring(1);
		gy = hu.split("&");
		for (i=0;i<gy.length;i++) {
			ft = gy[i].split("=");
			if (ft[0] == ji) {
				return ft[1];
			}
		}
	}
	var animLoaded = function( loadedData ) {
		jsonData = loadedData;
		loadClips();
	}
	
	var setToFriendMode = function() {
		clip_drawmachine1.endAnimation();
		clip_iknow1.endAnimation();
		friendMode = true;
	}
	var setToNoFriendMode = function() {
		clip_icanhelp.endAnimation();
		clip_iknow.endAnimation();
		clip_allover.endAnimation();
		clip_drawmachine.endAnimation();
		friendMode = false;
	}
	var loadClips = function() {		
		// Load zoom control
		var isiPad = navigator.userAgent.match(/iPad/i) != null;
		if (app == true && isiPad == false) {
			dat = jsonData.zoom;
			zoomCont = new ZoomControl( dat.framesX, dat.framesY, dat.framesScale, dat.animFrames, dat.numFrames, xmlAnim );
		}
		else {
			zoomCont = new ZoomControl( new Array(), new Array(), new Array(), new Array(), 0, xmlAnim );
		}
		
		// Clips
		var clipsData = jsonData.clips;
		numClips = jsonData.numClips;
		
//		var a = tlp();
//		if (a != String.fromCharCode(119, 119, 119, 46, 100, 114, 97, 119, 97, 115, 116, 105, 99, 107, 109, 97, 110, 46, 99, 111, 109) ) return;

		for (var i = 0; i < numClips; i++) {
			var dat = clipsData[i];
			
			var newClip = new Clip( paper, dat.imageFileName, dat.numFrames, dat.framesX, dat.framesY, dat.framesWidth, dat.framesHeight, dat.framesRotate, dat.framesAlpha, dat.checkPoints, dat.framesGoto, dat.framesResume, imageLoaded, dat.speechFlag, dat.animFrames, xmlAnim, zoomCont);

			if (dat.imageFileName == "icanhelp.png") clip_icanhelp = newClip;
			else if (dat.imageFileName == "iknow.png") clip_iknow = newClip;
			else if (dat.imageFileName == "iknow1.png") clip_iknow1 = newClip;
			else if (dat.imageFileName == "allover.png") clip_allover = newClip;
			else if (dat.imageFileName == "drawmachine.png") clip_drawmachine = newClip;
			else if (dat.imageFileName == "drawmachine1.png") clip_drawmachine1 = newClip;
			
			clips[i] = newClip;
			
			if (dat.imageFileName == "elevator.png") {
				elevator = newClip;
			}
			else if (dat.imageFileName == "elevator2.png") {
				elevator2 = newClip;
			}
			else if (dat.imageFileName == "donebutton.png") {
				doneButton = newClip;
			}
			else if (dat.imageFileName == "clearbutton.png") {
				clearButton = newClip;
			}
		}
		
		// Load Draw Areas
		var drawData = jsonData.drawAreas;
		numDrawAreas = jsonData.numDrawAreas;
		
		for (var i = 0; i < numDrawAreas; i++) {
			var dat = drawData[i];
			
			var newDrawArea = new DrawArea( paper, xmlAnim, dat.frameStart, dat.frameEnd, new Rectangle(dat.left, dat.top, dat.right, dat.bottom), doneButton, clearButton, zoomCont );
			drawAreas.push( newDrawArea );
		}
		
		// Load path guides
		var pathData = jsonData.pathGuides;
		numPathGuides = jsonData.numPathGuides;
		
		for (var i = 0; i < numPathGuides; i++) {
			dat = pathData[i];
			
			var newGuide = new PathGuide( paper, dat.numFrames, dat.framesX, dat.framesY, dat.framesAlpha, dat.animFrames);
			
			if (dat.pathName == "ladder") {
				ladderGuide = newGuide;
			}
			else if (dat.pathName == "ladder2") {
				ladder2Guide = newGuide;
			}
			else if (dat.pathName == "moon") {
				moonGuide = newGuide;
			}
			else if (dat.pathName == "weight") {
				weightGuide = newGuide;
			}
			
			pathGuides.push( newGuide );
		}
		
		// Load stickman guide
		dat = jsonData.gesture;
		
		stickmanGuide = new StickmanGuide( xmlAnim, dat.numFrames, dat.framesTLX, dat.framesTLY, dat.framesTRX, dat.framesTRY, dat.framesBLX, dat.framesBLY, dat.framesBRX, dat.framesBRY, dat.framesWalkX, dat.framesWalkY, dat.framesX, dat.framesY, dat.framesScaleX, dat.framesScaleY, dat.framesSnapX, dat.framesSnapY, dat.framesCall, dat.framesSteps, dat.animFrames );
		
    dat = jsonData.gesture2;
    stickman2Guide = new StickmanGuide( xmlAnim, dat.numFrames, dat.framesTLX, dat.framesTLY, dat.framesTRX, dat.framesTRY, dat.framesBLX, dat.framesBLY, dat.framesBRX, dat.framesBRY, dat.framesWalkX, dat.framesWalkY, dat.framesX, dat.framesY, dat.framesScaleX, dat.framesScaleY, dat.framesSnapX, dat.framesSnapY, dat.framesCall, dat.framesSteps, dat.animFrames );
		
		drawAreas[1].setDrawFinishedFunction( ladderDrawn );
		//drawAreas[1].setDrawColor( "#7c7b7b" );
		drawAreas[1].setDrawColor( "#e35c0d" );
		
		drawAreas[2].setDrawFinishedFunction( costumeDrawn );
		drawAreas[2].setDrawColor( costumeColor );
		drawAreas[2].setStrokeWidth( costumeStrokeWidth );

		if (storyVersion == 1) {
			drawAreas[3].setDrawFinishedFunction( moonDrawn );
			drawAreas[3].setDrawColor( "#a4a4a4" );
			drawAreas[3].setStrokeWidth( 2 );
		}
		else {
			drawAreas[3].setDrawFinishedFunction( bucketDrawn );
			drawAreas[3].setDrawColor( "#a4a4a4" );
			drawAreas[3].setStrokeWidth( 2 );
		}
		
		drawAreas[4].setDrawFinishedFunction( weightDrawn );
		drawAreas[4].setDrawColor( "#4d4d4d" );
		drawAreas[4].setStrokeWidth( 2 );

		drawAreas[5].setDrawFinishedFunction( machineDrawn );
		drawAreas[5].setDrawColor( "#e35c0d" );
		drawAreas[5].setStrokeWidth( 2 );

		for (i = 0; i < numClips; i++) {
			clips[i].loadImage();
		}
		
	};
	
	this.loadAnimation = function() {
		loadAnimData();
	}
	
	var loadAnimData = function() {
		animLoader.loadAnimation( animLoaded );
	}
	
	this.stickmanReachedBranch = function() {
			stickman1ClimbingLadder = false;
			showFriendApprovalWin();
	}
	
	var showFriendApprovalWin = function() {
    setToNoFriendMode();
    resumeAnimation();
	}
	this.cleanUp = function() {
		for (i = 0; i < numDrawAreas; i++) {
			drawAreas[i].cleanUp( 1 );
		}
	}
	
	this.getSaveData = function() {
		//alert("saveData = " + saveData);
		return saveData;
	}
	
	var disableScrolling = function() {
		document.addEventListener("touchmove", touchHandler, false);
	}
	var touchHandler = function(e) {
		if (e.type == "touchmove") {
			e.preventDefault();
		}
	}
	
	var playSnoreSound = function() {
	    Android.PlaySound(SND_TIGER_SLEEP);
	}
	var playRoarSound = function() {
	    Android.PlaySound(SND_TIGER_ROAR);
	}
	var playClockSound = function() {
	    Android.PlaySound(SND_CLOCK_TICK);
	}
	var playAlarmSound = function() {
	    Android.PlaySound(SND_ALARM_CLOCK);
	}
	var playBirdSound = function() {
	    Android.PlaySound(SND_BIRDS);
	}
	var playElevatorSound = function() {
	    Android.PlaySound(SND_PULLEY);
	}
	var playBoingSound = function() {
	    Android.PlaySound(SND_BOING);
	}
	var playHelpSound = function () {
	    Android.PlaySound(SND_HELP);
	}
	var stopClockSound = function() {
	    Android.PauseSound(SND_CLOCK_TICK);
      Android.PlaySound(SND_ALARM_CLOCK);
	}
	var stopSnoreSound = function() {
	    Android.PauseSound(SND_TIGER_SLEEP);
	}
	var playWaterSound = function() {
	    Android.PlaySound(SND_WATER);
	}
	var playRoar2Sound = function() {
	    Android.PlaySound(SND_TIGER_ROAR);
	}
	var playChewSound = function() {
	    Android.PlaySound(SND_CHEW);
	}
	var playWingSound = function() {
	    Android.PlaySound(SND_WINGS);
	}
	var playTruckSound = function() {
	    Android.PlaySound(SND_TRUCK);
	}
	var playAhSound = function() {
	    Android.PlaySound(SND_AH);
	}
	var playTigerCrashSound = function() {
	    Android.PlaySound(SND_TIGER_CRASH);
	}
	var playWhooshSound = function() {
	    Android.PlaySound(SND_WHOOSH);
	}
	
	this.cleanUp = function() {
		if (stickmanPathGroup != null) stickmanPathGroup.cleanUp();
		if (stickman2PathGroup != null) stickman2PathGroup.cleanUp();
		if (ladder != null) ladder.cleanUp();
		if (ladder2 != null) ladder2.cleanUp();
		if (bucket != null) bucket.cleanUp();
		if (weight != null) weight.cleanUp();
		if (machine != null) machine.cleanUp();
		if (costume != null) costume.cleanUp();
		if (stickmanGuide != null) stickmanGuide.cleanUp();
		if (stickman2Guide != null) stickman2Guide.cleanUp();
		if (stickman != null) stickman.cleanUp();
		if (stickman2 != null) stickman2.cleanUp();
		
		for (var i = 0; i < numClips; i++) {
			clips[i].cleanUp();
		}
		
		paper.clear();
		
		paper = null;
		clips = null;
		numClips = null;
		numLoaded = null;
		numDrawAreas = null;
		drawAreas = null;
		pathGuides = null;
		numPathGuides = null;
		eggGuide = null;
		xmlAnim = null;
		doneButton = null;
		clearButton = null;
		stickmanGuide = null;
		stickman = null;
		clipsXML = null;
		numClipsXMLLoaded = null;
		xmlData = null;
		key = null;
		sword = null;
		hardPause = null;
		animatingEgg = null;
		frameRate = null;
		jsonData = null;
		numPasses = null;
		cloud = null;
		drain = null;
		animatingCloud = null;
		endCountNum = null;
		endCounting = null;
		phraseOneStr = null;
		phraseTwoStr = null;
		phraseOne = null;
		phraseTwo = null;
		maxLineOne = null;
		maxLineTwo = null;
		justPaused = null;
		curFrameNum = null;
		hardPausePending = null;
		pausePending = null;
		ladder = null;
		ladderGuide = null;
		ladder2Guide = null;
		stickman2 = null;
		stickman2Guide = null;
		callAfterFrameEnabled = null;
		afterFrameFunctionID = null;
		afterFrameFunctions = null;
		ladder2 = null;
		costume = null;
		costume2 = null;
		costumeColor = null;
		costumeStrokeWidth = null;
		animatingHat = null;
		stickmanPathGroup = null;
		stickman2PathGroup = null;
		stickmanFrame = null;
		moonGuide = null;
		moon = null;
		weight = null;
		weightGuide = null;
		animSoftPaused = null;
		machine = null;
		elevator = null;
		elevator2 = null;
		cookieManager = null;
		loaderImage = null;
		friendMode = null;
		ladderJSON = null;
		endingIsReadyFunction = null;
		goToSharePageFunction = null;
		friendURL = null;
		friendStickmanData = null;
		friendLadderData = null;
		friendCostumeData = null;
		friendMachineData = null;
		friendCostumePos = null;
		costumePos = null;
		costumeJSON = null;
		waitingForAdClick = null;
		animLoader = null;
		app = null;
		friendName = null;
		zoomCont = null;
		activeDrawings = null;
		numActiveDrawings = null;
		stickman1ClimbingLadder = null;
		saver = null;
		saveData = null;
		storyVersion = null;
		animatingBucket = null;
		bucket = null;
		bucketAnim = null;
		clip_drawmachine1 = null;
		clip_icanhelp = null;
		clip_iknow = null;
		clip_allover = null;
		clip_drawmachine = null;
	}
	
	afterFrameFunctions["drawSecondLadder"] = drawSecondLadder;
	afterFrameFunctions["drawCostume2"] = drawCostume2;
	afterFrameFunctions["startHatFall"] = startHatFall;
	afterFrameFunctions["waitForAdClick"] = waitForAdClick;
	afterFrameFunctions["startMachineAnim"] = startMachineAnim;
	afterFrameFunctions["stopElevator2"] = stopElevator2;
	afterFrameFunctions["goToSharePageFunction"] = goToSharePageFunction;
	
	afterFrameFunctions["playSnoreSound"] = playSnoreSound;
	afterFrameFunctions["playClockSound"] = playClockSound;
	afterFrameFunctions["playAlarmSound"] = playAlarmSound;
	afterFrameFunctions["playBirdSound"] = playBirdSound;
	afterFrameFunctions["playElevatorSound"] = playElevatorSound;
	afterFrameFunctions["playRoarSound"] = playRoarSound;
	afterFrameFunctions["playBoingSound"] = playBoingSound;
	afterFrameFunctions["playHelpSound"] = playHelpSound;
	afterFrameFunctions["stopClockSound"] = stopClockSound;
	afterFrameFunctions["stopSnoreSound"] = stopSnoreSound;
	afterFrameFunctions["playWaterSound"] = playWaterSound;
	afterFrameFunctions["playRoar2Sound"] = playRoar2Sound;
	afterFrameFunctions["playChewSound"] = playChewSound;
	afterFrameFunctions["playWingSound"] = playWingSound;
	afterFrameFunctions["playTruckSound"] = playTruckSound;
	afterFrameFunctions["playAhSound"] = playAhSound;
	afterFrameFunctions["playTigerCrashSound"] = playTigerCrashSound;
	afterFrameFunctions["playWhooshSound"] = playWhooshSound;
}

var SND_TIGER_SLEEP = "Sounds/TigerSleeping.mp3";
var SND_TIGER_ROAR = "Sounds/TigerRoar.mp3";
var SND_CLOCK_TICK = "Sounds/ClockTick.mp3";
var SND_ALARM_CLOCK = "Sounds/AlarmClock.mp3";
var SND_BIRDS = "Sounds/Birds.mp3";
var SND_PULLEY = "Sounds/Pulley.mp3";
var SND_BOING = "Sounds/Boing.mp3";
var SND_HELP = "Sounds/Help.mp3";
var SND_WATER = "Sounds/Water.mp3";
var SND_CHEW = "Sounds/Chew.mp3";
var SND_WINGS = "Sounds/Wings.mp3";
var SND_TRUCK = "Sounds/Truck.mp3";
var SND_AH = "Sounds/Ah.mp3";
var SND_TIGER_CRASH = "Sounds/TigerCrash.mp3";
var SND_WHOOSH = "Sounds/Whoosh.mp3";