function XMLAnim( _paper, _xmlFileName) {
	var paper = _paper;
	var xmlFileName = _xmlFileName;
	var clips = new Array();
	var numClips = 0;
	var numLoaded = 0;
	var numDrawAreas = 0;
	var drawAreas = new Array();
	var pathGuides = new Array();
	var numPathGuides = 0;
	var eggGuide = 0;
	var xmlAnim = this;
	var doneButton;
	var clearButton;
	var stickmanGuide;
	var stickman;
	var clipsXML;
	var numClipsXMLLoaded;
	var xmlData;
	var key;
	var sword;
	var hardPause = false;
	var animatingEgg = false;
	var frameRate = 40;
	var jsonData;
	var numPasses = 1;
	var cloud;
	var drain;
	var animatingCloud = false;
	var endCountNum = 0;
	var endCounting = false;
	var phraseOneStr = "Dream It";
	var phraseTwoStr = "Real";
	var phraseOne = new Array();
	var phraseTwo = new Array();
	var maxLineOne = 17;
	var maxLineTwo = 14;
	var justPaused = false;
	var numDrawFrame = 0;
	var numRegFrames = 0;
	var hardPausePending = false;
	var pausePending = false;
	var zoomCont;

	var imageLoaded = function(){
		numLoaded ++;
		if (numLoaded >= numClips) {
			disableScrolling();
			animateFrame();
		}
	}
	
	var disableScrolling = function() {
		document.addEventListener("touchmove", touchHandler, false);
	}
	var touchHandler = function(e) {
		if (!G.popup && e.type == "touchmove") {
			e.preventDefault();
		}
	}

	var animateFrame = function(){
		if (hardPause == true) {
			return;
		}
		var start = (new Date).getTime();
//		numPasses = 1;
//		if (justPaused == false) numPasses = 5;
		justPaused = false;
		for (var p = 0; p < numPasses; p++) {
			stickmanGuide.animateFrame( 1 );
//			var oldNumPasses = numPasses;
			numDrawFrame++;
			
			for (i = 0; i < numDrawAreas; i++) {
				drawAreas[i].animateFrame( 1 );
			}
			if (hardPausePending == true || pausePending == true) {
				numPasses = p + 1;
				break;
			}
		}
		numRegFrames += numPasses;
//			stickmanGuide.setNumFramesAnimated( numPasses );
//			if (justPaused == true) numPasses = 1;
			for (var i = 0; i < numClips; i++) {
				clips[i].animateFrame( numPasses );
			}
			for (i = 0; i < numPathGuides; i++) {
				pathGuides[i].animateFrame( numPasses );
			}
			if (animatingEgg == true) {
				var animFinished = egg.animateEgg( numPasses );
				if (animFinished == true) {
					animatingEgg = false;
				}
			}
			if (animatingCloud == true) {
				cloud.animateRain( numPasses );
			}
		//}
		//catch(e) {
		//	alert (e);
		//}
		if (hardPausePending == true) {
			executeHardPause();
		}
		if (pausePending == true) {
			executePause();
		}
		
		var diff = (new Date).getTime() - start;
		//var timeForNextFrame = 33 - diff;
		var timeForNextFrame = frameRate - diff;
		if (timeForNextFrame < 0) {
			numPasses = Math.round( -timeForNextFrame / frameRate ) + 2;
			if (numPasses > 5) numPasses = 5;
			//console.log(timeForNextFrame);
			//console.log(numPasses);
		} else numPasses = 1;
		//console.log(timeForNextFrame);
		if (timeForNextFrame <= 0) timeForNextFrame = 1;
		
		if (endCounting == true) {
			endCountNum++;
			if (endCountNum >= 260) {
				xmlAnim.scrollDownOverlay();
				executeHardPause();
				return;
			}
		}
		
		//var animateInterval = setTimeout(animateFrame,33);
		//var animateInterval = setTimeout(animateFrame,16);
		var animateInterval = setTimeout(animateFrame,timeForNextFrame);
	}
	this.pauseAnimation = function(){
		pausePending = true;
	}
	
	var executePause = function() {
		//console.log("pauseAnimation");
		pausePending = false;
		numPasses = 1;
		justPaused = true;
		for (var i = 0; i < numClips; i++) {
			clips[i].pauseAnimation();
		}
		for (var i = 0; i < numDrawAreas; i++) {
			drawAreas[i].pauseAnimation();
		}
		for (var i = 0; i < numPathGuides; i++) {
			pathGuides[i].pauseAnimation();
		}
		stickmanGuide.pauseAnimation();
	}
	this.pauseAll = function(){
		hardPausePending = true;
	}
	
	var executeHardPause = function() {
		//console.log("pauseAll");
		hardPausePending = false;
		hardPause = true;
		justPaused = true;
	}
	this.resumeAnimation = function(){
		//console.log("resumeAnimation");
		numPasses = 1;
		justPaused = true;
		for (var i = 0; i < numClips; i++) {
			clips[i].resumeAnimation();
		}
		for (i = 0; i < numDrawAreas; i++) {
			drawAreas[i].resumeAnimation();
		}
		for (i = 0; i < numPathGuides; i++) {
			pathGuides[i].resumeAnimation();
		}
		stickmanGuide.resumeAnimation();
		if (hardPause == true) {
			hardPause = false;
			animateFrame();
		}
	}
	
	this.scrollDownOverlay = function(){
		$('#overlay').animate({top: '460'},{duration: 1500}, function() {});
		
		for (var i = 0; i < numDrawAreas; i++) {
			// drawAreas[i].setPopupActive( true );
      G.popup = true;
		}
	}
	
	this.scrollUpOverlay = function(){
		$('#galleryInfoBox').animate({top: '-500' }, {duration: 1000 }, function() { });
		$('#overlay').animate({top: '-400' }, {duration: 1500 }, function() {});
		
		for (var i = 0; i < numDrawAreas; i++) {
			// drawAreas[i].setPopupActive( false );
      G.popup = false;
		}
	}

	this.setStickman = function( _stickman ) {
		stickman = _stickman;
		stickmanGuide.setStickman( stickman );
		for (var i = 0; i < numClips; i++) {
			clips[i].setStickman( stickman );
		}
	}
	
	this.setKey = function( _key ) {
		key = _key;
		stickman.holdItem( key );
		stickmanGuide.setNextWalkToUnlock( key );
//		frameRate = 33;
	}
	this.setEgg = function( _egg ) {
		egg = _egg;
		egg.setupEggFall( stickman.getFeetPosition().y + 45 );
		eggGuide.setPathGroup( egg );
		setTimeout(startEggDrop,300);
	}
	this.setCloud = function( _cloud ) {
		cloud = _cloud;
		cloud.setupRainCloud( stickman.getPathGroup() );
		animatingCloud = true;
		stickman.stopHoldingItem( sword );
		sword.clearDisplay();
		
		frameRate = 33;
	}
	this.setSword = function( _sword ) {
		sword = _sword;
		stickman.holdItem( sword );
		frameRate = 33;
	}
	this.drainDrawn = function( _drain ) {
		cloud.endRain();
		drain = _drain;
		animatingCloud = false;
		stickmanGuide.setSwirling( true );
		endCounting = true;
	}
	
	this.swirlingStarted = function() {
		drain.clearDisplay();
	}
	
	var startEggDrop = function() {
		animatingEgg = true;
	}

	var querySt = function(ji) {
		hu = window.location.search.substring(1);
		gy = hu.split("&");
		for (i=0;i<gy.length;i++) {
			ft = gy[i].split("=");
			if (ft[0] == ji) {
				return ft[1];
			}
		}
	}
	
	var setupPhrases = function() {
	
		var params = querySt("o");
		if (params != null) {
			var paramsArray = params.split("s");
			var firstParam = paramsArray[0];
			var secParam = paramsArray[1];
			var firstChars = firstParam.split("-");
			var secChars = secParam.split("-");
		}
		else {
			firstChars = new Array(66,69,32,67,82,69,65,84,73,86,69);
			secChars = new Array(69,86,69,82,89,32,68,65,89);
		}
		
		// Setup the phrase
		var numLetters = firstChars.length;
		phraseOne.push( "" );
		var phraseOneDisp = new Array();
		for (var i = 0; i < numLetters; i++) {
			var letter = String.fromCharCode( firstChars[i] ).toLowerCase();
			phraseOneDisp.push( letter.toUpperCase() );
			if (letter == "?") letter = "quest";
			else if (letter == "!") letter = "ex";
			else if (letter == ".") letter = "dot";
			else if (letter == "-") letter = "dash";
			else if (letter == ",") letter = "com";
			else if (letter == " ") letter = "blank";
			else if (letter == "&") letter = "and";
			else if (letter == "/") letter = "slash";
			else if (letter == "+") letter = "plus";
			else if (letter == "@") letter = "at";
			else if (letter == "\"") letter = "quot";
			else if (letter == "\'") letter = "apos";
			else if (letter == "$") letter = "dol";
			else if (letter == "%") letter = "perc";
			else if (letter == "#") letter = "hash";
			else if (letter == ">") letter = "grat";
			else if (letter == "<") letter = "les";
			phraseOne.push( letter );
		}
		$("#firstLine").val( phraseOneDisp.join("") );
		for (i = numLetters; i < maxLineOne; i++) {
			phraseOne.push( "blank" );
		}
		//alert(phraseOne);

		numLetters = secChars.length;
		phraseTwo.push( "" );
		var phraseTwoDisp = new Array();
		for (i = 0; i < numLetters; i++) {
			letter = String.fromCharCode( secChars[i] ).toLowerCase();
			phraseTwoDisp.push( letter.toUpperCase() );
			if (letter == "?") letter = "quest";
			else if (letter == "!") letter = "ex";
			else if (letter == ".") letter = "dot";
			else if (letter == "-") letter = "dash";
			else if (letter == ",") letter = "com";
			else if (letter == " ") letter = "blank";
			else if (letter == "&") letter = "and";
			else if (letter == "/") letter = "slash";
			else if (letter == "+") letter = "plus";
			else if (letter == "@") letter = "at";
			else if (letter == "\"") letter = "quot";
			else if (letter == "\'") letter = "apos";
			else if (letter == "$") letter = "dol";
			else if (letter == "%") letter = "perc";
			else if (letter == "#") letter = "hash";
			else if (letter == ">") letter = "grat";
			else if (letter == "<") letter = "les";
			phraseTwo.push( letter );
		}
		$("#secLine").val( phraseTwoDisp.join("") );
		for (i = numLetters; i < maxLineTwo; i++) {
			phraseTwo.push( "blank" );
		}
		setupShareLinks();
	}
	
	var loadClips = function() {
		var clipsData = jsonData.clips;
		numClips = jsonData.numClips;
		
		setupPhrases();
		
		var zoomX = new Object();
		var zoomY = new Object();
		var zoomScale = new Object();
		var zoomFrames = new Object();
		zoomX[0] = 0;
		zoomY[0] = 0;
		zoomScale[0] = .5;
		zoomFrames[0] = true;
		
		zoomCont = new ZoomControl( zoomX, zoomY, zoomScale, zoomFrames, 1, xmlAnim );

		for (var i = 0; i < numClips; i++) {
			var dat = clipsData[i];
			
			// Replace the letters
			if (dat.imageFileName.indexOf("letterb") != -1) {
				var img = dat.imageFileName;
				var first = img.split(".")[0];
				var num = first.substr( 7, first.length - 7 );
				var letterName = phraseTwo[ num ];
				dat.imageFileName = "letter" + letterName + ".png";
			}
			else if (dat.imageFileName.indexOf("letter") != -1) {
				var img = dat.imageFileName;
				var first = img.split(".")[0];
				var num = first.substr( 6, first.length - 6 );
				var letterName = phraseOne[ num ];
				dat.imageFileName = "letter" + letterName + ".png";
			}
			
			var newClip = new Clip( paper, dat.imageFileName, dat.numFrames, dat.framesX, dat.framesY, dat.framesWidth, dat.framesHeight, dat.framesRotate, dat.framesAlpha, dat.checkPoints, dat.framesGoto, dat.framesResume, imageLoaded, dat.speechFlag, dat.animFrames, xmlAnim, zoomCont);
			clips[dat.zIndex] = newClip;
			if (dat.imageFileName == "donebutton.png") {
				doneButton = newClip;
			}
			else if (dat.imageFileName == "clearbutton.png") {
				clearButton = newClip;
			}
		}
		
		// Load Draw Areas
		var drawData = jsonData.drawAreas;
		numDrawAreas = jsonData.numDrawAreas;
		
		for (var i = 0; i < numDrawAreas; i++) {
			var dat = drawData[i];
			
			var newDrawArea = new DrawArea( paper, xmlAnim, dat.frameStart, dat.frameEnd, new Rectangle(dat.left, dat.top, dat.right, dat.bottom), doneButton, clearButton, zoomCont );
			drawAreas.push( newDrawArea );
		}
		
		// Load path guides
		var pathData = jsonData.pathGuides;
		numPathGuides = jsonData.numPathGuides;
		
		for (var i = 0; i < numPathGuides; i++) {
			dat = pathData[i];
			
			var newGuide = new PathGuide( paper, dat.numFrames, dat.framesX, dat.framesY, dat.framesAlpha, dat.animFrames);
			
			if (dat.pathName == "egg") {
				eggGuide = newGuide;
			}
			
			pathGuides.push( newGuide );
		}

		
		// Load stickman guide
		dat = jsonData.gesture;
		stickmanGuide = new StickmanGuide( xmlAnim, dat.numFrames, dat.framesTLX, dat.framesTLY, dat.framesTRX, dat.framesTRY, dat.framesBLX, dat.framesBLY, dat.framesBRX, dat.framesBRY, dat.framesWalkX, dat.framesWalkY, dat.framesX, dat.framesY, dat.framesScaleX, dat.framesScaleY );

		drawAreas[1].drawAsKey();
		//drawAreas[1].setDrawColor( "#e56216" );
		drawAreas[1].setDrawColor( "#e58342" );
		
		drawAreas[2].drawAsEgg();
		drawAreas[2].setDrawColor( "#fd5b2a" );
		
		drawAreas[3].drawAsSword();
		drawAreas[3].setDrawColor( "#9f9f9f" );

		drawAreas[4].drawAsCloud();
		drawAreas[4].setDrawColor( "#888888" );
		
		drawAreas[5].drawAsDrain();
		drawAreas[5].setDrawColor( "#8c8f91" );

		for (i = 0; i < numClips; i++) {
			clips[i].loadImage();
		}
		
	};

	this.loadAnimation = function () {
	    //		$.ajax({
	    //		  url: 'animguides.js',
	    //		  dataType: 'JSONP',
	    //		  jsonpCallback: 'parseMe',
	    //		  success: function(data) {
	    //			  jsonData = data;
	    //			  loadClips();
	    //		  }
	    //		});
	    jsonData = globalData;
	    loadClips();
	}
	
	
}