var SPEECH = {
  AAAH: "AAAHHH",
  ALL_OVER: "IT'S ALL OVER!",
  BAD_BEAVER: "NO! \nBAD BEAVER!\n SHOO!",
  BE_CREATIVE: "ANTHING IS POSSIBLE \nYOU JUST HAVE TO BE CREATIVE",
  BOING: "BOING",
  CANT_LOOK: "OH I CAN'T \nLOOK!",
  CHOMP: "CHOMP",
  CLIMB_ON: "CLIMB ON",
  DRAW_A_LADDER: "CAN YOU DRAW \nA LADDER SO I \nCAN RESCUE THEM?",
  DRAW_A_WEIGHT: "CAN YOU DRAW \nA HEAVY WEIGHT \nIN THE OTHER \nELEVATOR CAR?",
  DRAW_A_BUCKET: "I HAVE AN IDEA! \nDRAW A BUCKET \nOF WATER IN MY \nHAND!",
  DRAW_MACHINE: "DRAW SOME \nWINGS ON THIS \nELEVATOR CAR SO \nIT CAN FLY!",
  EP_CLIMB_ON: "CLIMB ON",
  EVERY_DAY: "EVERY DAY",
  GOOD_COSTUME: "WHEW! \nGOOD THING \nI HAVE THIS \nCOSTUME",
  HANDY_ELEVATOR: "AN ELEVATOR! \nTHAT'S HANDY!",
  HELP: "HELP",
  HOO: "HOO",
  I_KNOW: "I KNOW! \nLET'S TURN \nTHIS ELEVATOR \nCAR INTO A FLYING \nMACHINE!",
  ITS_STUCK: "UH OH \nIT'S STUCK",
  NEED_TRAMPOLINE: "A GIANT TRAMPOLINE! \nTHAT'S WHAT WE NEED! \nQUICK, TOUCH THE AD \nAT THE BOTTOM OF \n THE SCREEN!",
  NO_COSTUME: "OH NO! \nMY COSTUME CAME OFF!",
  OH_NO: "OH NO!",
  PRESS_BACK_BUTTON: "QUICK! \nPRESS THE BACK BUTTON \nON OUR BROWSER SO WE \nWON'T HAVE TO SEE THE \nDISASTER!",
  RING: "RRRING",
  SOMEONE_IN_DANGER: "IT SOUNDS LIKE \nSOMEONE IS IN DANGER!",
  THANKS: "THANKS FOR THE HELP!",
  THE_END: "THE END",
  THINK_FAST: "WE HAVE TO \nTHINK OF SOMETHING \nFAST!",
  TICK: "TICK",
  TIGER_COSTUME: "CAN YOU DRAW \nA TIGER COSTUME \nON ME?",
  TWEET: "TWEET",
  UH_OH_TIGER: "UH OH \nA TIGER!",
  ZZZZ: "ZZZZ"
};

var FONT_SIZE = 24;

function getTextFor(imageFileName,paper,x,y){
  switch(imageFileName){
  case "aaah.png":
    return paper.text(x,y,SPEECH.AAAH).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "allover.png":
    return paper.text(x,y,SPEECH.ALL_OVER).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#e56b25"});
    break;
  case "badbeaver.png":
    return paper.text(x,y,SPEECH.BAD_BEAVER).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "becreative.png":
    return paper.text(x,y,SPEECH.BE_CREATIVE).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "boing.png":
    return paper.text(x,y,SPEECH.BOING).attr({"font-family": "gooddog", "font-size":FONT_SIZE * 3, fill:"#999"});
    break;
  case "cantlook.png":
    return paper.text(x,y,SPEECH.CANT_LOOK).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "chomp.png":
    return paper.text(x,y,SPEECH.CHOMP).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "climbon.png":
  case "epclimbon.png":
    return paper.text(x,y,SPEECH.CLIMB_ON).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "drawaladder.png":
    return paper.text(x,y,SPEECH.DRAW_A_LADDER).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "drawaweight.png":
    return paper.text(x,y,SPEECH.DRAW_A_WEIGHT).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "drawbucket.png":
    return paper.text(x,y,SPEECH.DRAW_A_BUCKET).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "drawmachine1.png":
    return paper.text(x,y,SPEECH.DRAW_MACHINE).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "everyday.png":
    return paper.text(x,y,SPEECH.EVERY_DAY).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "goodcostume.png":
    return paper.text(x,y,SPEECH.GOOD_COSTUME).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "handyelevator.png":
    return paper.text(x,y,SPEECH.HANDY_ELEVATOR).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "help1.png":
  case "help2.png":
    return paper.text(x,y,SPEECH.HELP).attr({"font-family": "gooddog", "font-size":FONT_SIZE * 1.2, fill:"#e25806"});
    break;
  case "hoo.png":
    return paper.text(x,y,SPEECH.HOO).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "iknow1.png":
    return paper.text(x,y,SPEECH.I_KNOW).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "itsstuck.png":
    return paper.text(x,y,SPEECH.ITS_STUCK).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "needtrampoline.png":
    return paper.text(x,y,SPEECH.NEED_TRAMPOLINE).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "nocostume.png":
    return paper.text(x,y,SPEECH.NO_COSTUME).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "ohno.png":
    return paper.text(x,y,SPEECH.OH_NO).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "pressbackbutton.png":
    return paper.text(x,y,SPEECH.PRESS_BACK_BUTTON).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "ring.png":
    return paper.text(x,y,SPEECH.RING).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#e56b25"});
    break;
  case "someoneindanger.png":
    return paper.text(x,y,SPEECH.SOMEONE_IN_DANGER).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "thanks.png":
    return paper.text(x,y,SPEECH.THANKS).attr({"font-family": "gooddog", "font-size":FONT_SIZE * 0.8, fill:"#999"});
    break;
  case "theend.png":
    return paper.text(x,y,SPEECH.THE_END).attr({"font-family": "gooddog", "font-size":FONT_SIZE * 4, fill:"#999"});
    break;
  case "thinkfast.png":
    return paper.text(x,y,SPEECH.THINK_FAST).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "tick.png":
    return paper.text(x,y,SPEECH.TICK).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "tigercostume.png":
    return paper.text(x,y,SPEECH.TIGER_COSTUME).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "tweet.png":
    return paper.text(x,y,SPEECH.TWEET).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#e56b25"});
    break;
  case "uhohtiger.png":
    return paper.text(x,y,SPEECH.UH_OH_TIGER).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  case "zzzz.png":
    return paper.text(x,y,SPEECH.ZZZZ).attr({"font-family": "gooddog", "font-size":FONT_SIZE, fill:"#999"});
    break;
  }
  return "";
}